// PICSLabelRatings.java
// by Yang-hua Chu
// last update: 10/11/96

package w3c.pics.label;

import java.io.* ;
import java.net.*;
import java.util.*;
import w3c.pics.util.*;


// potential problem: hastable cannot be ordered
public class PICSLabelRatings extends Hashtable {
  
  private boolean DEBUG = false;

  public boolean parse(SExp exp)
       throws PICSParseException
  {
    int initCnt = this.size();
    if (DEBUG) System.out.println(exp.toString());
    while (exp.expect(exp.SEXP_IDENT)) {
      String name = exp.current().getString();
      if (exp.expect(exp.SEXP_NUMBER)) {
	//this.put(name, exp.current().getNumber());
	String s = "" + exp.current().getNumber();
	this.put(name, s);
      } else {
	exp.pushBack();   // fail safe, but you may want to signal
	break;
      }
    }
    return (this.size() != initCnt);
  }

  public String toString()
  {
    String s = "\nratings (";
    
    Enumeration ratings = this.keys();
    while (ratings.hasMoreElements()) {
      Object key = ratings.nextElement();
      s += " " + key.toString() + " " + this.get(key).toString();
    }
    return s + ")";
  }

}
