// ReturnedValues.java
// by Yang-hua Chu
// last update: 10/11/96

package w3c.pics.referee;

import java.io.* ;
import java.net.*;
import java.util.*;

public class ReturnedValues {
  
  private TriValue val;
  private StatementList list = new StatementList();

  public ReturnedValues()
  {
    this.val = new TriValue();
  }

  public ReturnedValues(TriValue val)
  {
    this.val = val;
  }

  public ReturnedValues(StatementList list)
  {
    this.list = list;
  }

  public ReturnedValues(TriValue val, StatementList list)
  {
    this.val = val;
    this.list = list;
  }

  public TriValue getTriValue()
  {
    return this.val;
  }

  public StatementList getStatementList()
  {
    return this.list;
  }

  public void setTriValue(TriValue val)
  {
    this.val = val;
  }

  public void setStatementList(StatementList list)
  {
    this.list = list;
  }
  
  public String toString()
  {
    String s = "( ( Tri-Value " + val.toString() + " )\n";
    s += "  ( Statement List " + list.toString() + "\n   ) )";
    return (new SExp(s)).toString();
  }
}
